UNIT Tckn_est_obj_unit;

INTERFACE

USES
  Classes, SysUtils, Maths32, Useful, Tuseful_obj_unit, D_Tuseful_obj_unit;

  // Preprocessor will scan this, find the {AUTOINIT}, {AUTODEC}, {MANUAL} aka single-line {},
  // ... and end-typedef statements,
  // ... and prepare various "auto...pas" files accordingly. These will be included via the $I directives

CONST
  code_for_female = 1;
  code_for_male = 2;

TYPE
  Tckn_est_obj = CLASS( D_Tuseful_obj)
    {AUTOINIT}
    npar, npar_nsa_y1, npar_nys_a1_reqm, npar_surv, npar_tresid, npar_daily_reprodm,
    npar_vb_mean_Linf, npar_vb_k, npar_vb_t0, npar_vb_cv_Linf, npar_fec_unc,
    rct_is_re,
    {MANUAL}
    curipar, min_sex, max_sex, n_sex, male, female, n_rct_re,
    {AUTOINIT}
    min_ad_l, max_ad_l, n_ad_l,
    min_ad_a, max_ad_a, n_ad_a, min_ad_yr, min_ad_yr_p1, max_ad_yr_min1, max_ad_yr, n_ad_yr_min1, n_ad_yr,
    min_jub_yr, max_jub_yr, n_jub_yr,
    nu_lata: INTEGER;
    reflen, tamer: DOUBLE;
    {AUTODEC}
    t_or_norm, i_reflen: INTEGER;
    taming{npar}: ARRAY_1D;
    rct_re{n_rct_re}: ARRAY_1D;
    rct_re_var, log_rct_re_var: DOUBLE;
    pls_pres_ysl{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l},
      pls_adult_ysl{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_3D;
    pl_sa{ min_sex:max_sex, min_ad_l:max_ad_l, min_ad_a:max_ad_a}: ARRAY_3D;
    punder{ min_sex:max_sex, min_ad_a:max_ad_a},
      fec_under{ min_sex:max_sex, min_ad_a:max_ad_a},
      lunder{ min_sex:max_sex, min_ad_a:max_ad_a}: ARRAY_2D;
    punder_pres_ysa{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_a:max_ad_a}: ARRAY_3D;
    nhat_ad_sa{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_a:max_ad_a},
      phat_ad_sa{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_a:max_ad_a},
      phat_a_given_s{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_a:max_ad_a}: ARRAY_3D;

    {AUTOINIT}
    rs_a_given_ls{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l, min_ad_a:max_ad_a}: ARRAY_4D;
    {AUTODEC} tot_rs_a_given_ls{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_3D;
    // Next computed only on request, in diagnostics
    e_rs_a_given_ls{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l, min_ad_a:max_ad_a}: ARRAY_4D;

    {AUTOINIT}
    rs_ls{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_3D;
    rs_l_nos{ min_ad_yr:max_ad_yr, min_ad_l:max_ad_l}: ARRAY_2D;
    pls_adjustor{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_3D;
    {AUTODEC}
    tot_rs_ls{ min_ad_yr:max_ad_yr}, tot_rs_l_nos{ min_ad_yr:max_ad_yr}: ARRAY_1D;
    inv_pls_adjustor{ min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_3D;
    mean_xs_pg_a{ min_ad_yr:max_ad_yr, min_sex:max_sex}: ARRAY_2D;

    {AUTODEC}
    // POPs: comps grouped as next-- don't need indiv recs by juve or adult
    n_pcomps_ls{ min_jub_yr:max_jub_yr, min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_4L;
    n_pcomps_no_ls{ min_jub_yr:max_jub_yr, min_ad_yr:max_ad_yr}: ARRAY_2L;
    expect_pops_ls{ min_jub_yr:max_jub_yr, min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_4D;
    expect_pops_no_ls{ min_jub_yr:max_jub_yr, min_ad_yr:max_ad_yr}: ARRAY_2D;

    {AUTOINIT}
    n_ju, n_ad: INTEGER; // genotyped
    ju_by{ n_ju}: ARRAY_1L; // per-animal. NB ad_len etc can be NA
    ad_len{ n_ad}, ad_sex{ n_ad}, ad_ycap{ n_ad}, ad_age{ n_ad}: ARRAY_1L;

    // Lookup tables into ju_by, ad_sex etc
    n_pop_als, n_pop_no_als: INTEGER; // how many... no_als means no ad age/len/sex...
    ju_pop_als{ n_pop_als}, ad_pop_als{ n_pop_als},
      ju_pop_no_als{ n_pop_no_als}, ad_pop_no_als{ n_pop_no_als}: ARRAY_1L;

    {AUTODEC}
    p_a_lspop{ min_jub_yr:max_jub_yr, min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l, min_ad_a:max_ad_a}: ARRAY_5D;
    p_pop_ls{ min_jub_yr:max_jub_yr, min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_4D;
    p_pop_no_ls{ min_jub_yr:max_jub_yr, min_ad_yr:max_ad_yr}: ARRAY_2D;
    // diagnostic only:
    keep_fec_ls{ min_jub_yr:max_jub_yr, min_ad_yr:max_ad_yr, min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_4D;

    spl_y2{min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_2D;
    spl_u{ min_ad_l:max_ad_l}: ARRAY_1D;
    log_daily_reprodf{min_ad_l:max_ad_l}: ARRAY_1D;
    delta_fec_unc{npar_fec_unc}: ARRAY_1D;

    daily_reprod{ min_sex:max_sex, min_ad_l:max_ad_l},
      lnfec{ min_sex:max_sex, min_ad_l:max_ad_l},
      fec{ min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_2D;
    inv_tot_fec{ min_jub_yr:max_jub_yr, min_sex:max_sex}: ARRAY_2D;

    vb_mean_Linf{min_sex:max_sex}, vb_k{min_sex:max_sex},
      vb_t0{min_sex:max_sex}, vb_cv_Linf{min_sex:max_sex}: ARRAY_1D;

    tresid{ min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_2D;
    tresid_under{ min_sex:max_sex, min_ad_a:max_ad_a}: ARRAY_2D;
    // qsel{ min_sex:max_sex, min_ad_l:max_ad_l}: ARRAY_2D;
    psurv{ min_ad_yr:max_ad_yr_min1, min_ad_a:max_ad_a}: ARRAY_2D;
    tot_mort_y1{ min_sex:max_sex}: ARRAY_1D;

    {AUTOINIT}
    // These would run slightly faster if the npar dim was moved to front
    log_nsa_y1_desmat{ min_sex:max_sex, min_ad_a:max_ad_a, npar_nsa_y1}: ARRAY_3S;
    log_nys_a1_reqm_desmat{ min_ad_yr_p1:max_ad_yr, min_sex:max_sex, npar_nys_a1_reqm}: ARRAY_3S;
    logit_surv_desmat{ min_ad_yr:max_ad_yr_min1, min_ad_a:max_ad_a, npar_surv}: ARRAY_3S;
    log_vb_mean_Linf_desmat{min_sex:max_sex, npar_vb_mean_Linf}: ARRAY_2S;
    log_vb_k_desmat{min_sex:max_sex, npar_vb_k}: ARRAY_2S;
    I_vb_t0_desmat{min_sex:max_sex, npar_vb_t0}: ARRAY_2S;
    log_vb_cv_Linf_desmat{min_sex:max_sex, npar_vb_cv_Linf}: ARRAY_2S;
    logit_tresid_desmat{ min_sex:max_sex, min_ad_l:max_ad_l, npar_tresid}: ARRAY_3S;
    log_daily_reprodm_desmat{ min_ad_l:max_ad_l, npar_daily_reprodm}: ARRAY_2S;
    fec_unc_desmat{min_ad_l:max_ad_l,npar_fec_unc}: ARRAY_2S;
    fec_unc_penmat{npar_fec_unc,npar_fec_unc}: ARRAY_2S;
    base_log_daily_reprodf{min_ad_l:max_ad_l}: ARRAY_1S;
    mean_pg_a_y1{min_sex:max_sex}: ARRAY_1D;

    {AUTODEC}
    partemp{npar}, pardir{npar}, dummy_deriv{npar}, this_d2{npar}: ARRAY_1D;
    hesso{npar,npar}: ARRAY_2D;

    {$I ckn_auto_method_headers.pas}
  END;

IMPLEMENTATION

CONSTRUCTOR Tckn_est_obj. create( {$I ckn_auto_constructor_args.pas});
{RARGS create NAOK=TRUE}
VAR
  i_yr, i_l, i_s, i_a, ipar: INTEGER;
  tot: DOUBLE;
BEGIN
  {$I ckn_auto_constructor_setup_scalars.pas}
  // All automatic except sex, which doesn't need params
  min_sex:= 1;
  max_sex:= 2;
  female:= code_for_female;
  male:= code_for_male; // code should be independent of ordering here-- just need to set to something!
  n_sex:= 2;
  IF (nu_lata>0) AND (nu_lata MOD 2=1) THEN BEGIN
    RAISE ERangeError.Create( 'For t-distro growth, nu must be even, or <= 0 for Normal');
  END;
  IF nu_lata>0 THEN BEGIN
    t_or_norm:= 2;
    set_n_nueven( t_or_norm);
    set_nueveni( nu_lata, t_or_norm);
  END ELSE BEGIN
    t_or_norm:= 1; // nueven_i=1 always means Normal
  END;

  n_rct_re:= 0;
  IF rct_is_re>0 THEN BEGIN
    n_rct_re:= (max_ad_a-min_ad_a) + (max_ad_yr-min_ad_yr); // one less than each
  END;

  IF (reflen>max_ad_l) OR (reflen<min_ad_l) THEN BEGIN
    RAISE ERangeError.Create( 'reflen must be inside length range');
  END;

  i_reflen:= TRUNC( reflen);

  {$I ckn_auto_constructor_setup_arrays.pas}
  // taming ON for everything not N- or VB-related
  FOR ipar:= 1 TO npar DO BEGIN
    taming[ ipar]:= 1; // will later be set to 0 for N-related
  END;

  // Now just total up some stuff:
  // Len & sex samples:

  // tot_rs_a_given_ls[ yr][ len][ sex]
  FOR i_yr:= min_ad_yr TO max_ad_yr DO BEGIN
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        tot:= 0;
        FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
          INCR( tot, rs_a_given_ls[ i_yr][ i_s][ i_l][ i_a]);
        END;
        tot_rs_a_given_ls[ i_yr][ i_s][ i_l]:= tot;
      END;
    END;
  END;

  // Len samples:
  FOR i_yr:= min_ad_yr TO max_ad_yr DO BEGIN
    tot:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        INCR( tot, rs_ls[ i_yr][ i_s][ i_l]);
      END;
    END;
    tot_rs_ls[ i_yr]:= tot;
  END;

  FOR i_yr:= min_ad_yr TO max_ad_yr DO BEGIN
    tot:= 0;
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      INCR( tot, rs_l_nos[ i_yr][ i_l]);
    END;
    tot_rs_l_nos[ i_yr]:= tot;
  END;

  FOR i_yr:= min_ad_yr TO max_ad_yr DO BEGIN
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        inv_pls_adjustor[ i_yr][ i_s][ i_l]:= 1/pls_adjustor[ i_yr][ i_s][ i_l];
      END;
    END;
  END;

  // Last & least: init mean age in plus-group
  mean_xs_pg_a[ min_ad_yr][ min_sex]:= mean_pg_a_y1[ min_sex] - max_ad_a;
  mean_xs_pg_a[ min_ad_yr][ max_sex]:= mean_pg_a_y1[ max_sex] - max_ad_a;

  // PCOMPS DONE SEPARATELY!!
END;

{$IFNDEF AD}
PROCEDURE Tckn_est_obj. init_pcomps_from_usable_exportee(
  CONST
    _is_usable: ARRAY_1SHINT);
{RDONTDOTHISARGS init_pcomps_from_usable DUP=FALSE}
{RCALLSEQ init_pcomps_from_usable 1}
VAR
  is_usable: ARRAY_2SHINT; // big but temporary-- don't need to keep-- pass in with dup=FALSE and don't tr()
  i_ad, i_ju: INTEGER;
BEGIN
  // Wrapping test <> 0 below, because I'm paranoid about a TRUE value of 127...
  // Pcomps:
  is_usable:= alloc_array( @_is_usable[1], [ n_ad, n_ju], [1,1], SizeOf( is_usable[1][1]));
  zero( n_pcomps_ls[ min_jub_yr][ min_ad_yr][ min_sex][ min_ad_l], n_jub_yr * n_ad_yr * n_sex * n_ad_l);
  zero( n_pcomps_no_ls[ min_jub_yr][ min_ad_yr], n_jub_yr * n_ad_yr);
  FOR i_ju:= 1 TO n_ju DO BEGIN
    FOR i_ad:= 1 TO n_ad DO BEGIN
      IF (ad_len[ i_ad]>0) AND (ad_sex[ i_ad]>0) THEN BEGIN
        // If I was sure that usable[] was 1 or 0, it'd just be += usable
        n_pcomps_ls[ ju_by[ i_ju]][ ad_ycap[ i_ad]][ ad_sex[ i_ad]][ ad_len[ i_ad]] +=
            one_if[ is_usable[ i_ad][ i_ju]<>0];
            // BYTE( is_usable[ i_ad][ i_ju]<>0);
      END ELSE BEGIN // if length missing, then major SNAFU; assume sex missing too
        n_pcomps_no_ls[ ju_by[ i_ju]][ ad_ycap[ i_ad]] += one_if[ is_usable[ i_ad][ i_ju]<>0];
         // was: BYTE( is_usable[ i_ad][ i_ju]<>0);
      END; // if ad len OK
    END; // ad-loop
  END; // ju-loop
  dealloc( is_usable); // just the pointers
END;

PROCEDURE Tckn_est_obj. set_rct_re_var_exportee(
  CONST
    _log_rct_re_var: DOUBLE);
BEGIN
  log_rct_re_var:= _log_rct_re_var;
  rct_re_var:= EXP( log_rct_re_var);
END;

{$ENDIF}{AD} {not!}

FUNCTION Tckn_est_obj. lglk(
    CONST
      parvec{npar}: ARRAY_1D):
  DOUBLE;
BEGIN
  // Approach is deliberately formulaic
  // For each "type" of parameter-driven entity:
  // 1. apply desmat to each block of params, one "row" per combo of age/sex/yr etc;
  // 2. then transform / expand if reqd

//   curipar:= 0;
//   zero( psurv[ min_ad_yr][ min_ad_a], n_ad_yr_min1 * n_ad_a);
//   zero( nhat_ad_sa[ min_ad_yr][ min_sex][ min_ad_a], n_ad_yr * n_sex * n_ad_a);
//   zero( tot_mort_y1[ min_sex], n_sex);
//   zero( vb_mean_Linf[ min_sex], n_sex);
//   zero( vb_k[ min_sex], n_sex);
//   zero( vb_t0[ min_sex], n_sex);
//   zero( vb_cv_Linf[ min_sex], n_sex);
//   zero( tresid[ min_sex][ min_ad_l], n_sex * n_ad_l);
//   zero( tresid_under[ min_sex][ min_ad_a], n_sex * n_ad_a);
//   zero( inv_tot_fec[ min_jub_yr][ min_sex], n_jub_yr * n_sex);
//   zero( fec[ min_sex][ min_ad_l], n_sex * n_ad_l);
//   zero( lnfec[ min_sex][ min_ad_l], n_sex * n_ad_l);
//   zero( fec[ male][ min_ad_l], n_ad_l);
//
//
  // unpack_surv( parvec); // surv before n_yr1, since former is needed by latter
  // unpack_nsa_y1( parvec); // n_yr1 before nys_a1_reqm which needs n_yr1 & surv
  // unpack_nys_a1_reqm( parvec);
  // propagate_n();
  // unpack_growth( parvec);
  // unpack_tresid( parvec);
  // unpack_male_daily_reprod( parvec);
  // set_fec();


//BEGIN
//  set_params( parvec);

  RESULT:= lata_lglk( parvec); // must do first, since it sets pls_adult_ysl[] and punder_pres_ysa
  // FOR curipar:= 1 TO npar DO BEGIN
  //    RESULT -= tamer * taming[ curipar] * SQR( parvec[ curipar];
  // END;

  // set_tot_fec(); // lata_lglk calculates some necessaries
  // RESULT+= pop_lglk(); for now, lata_lglk inlines everything including pop_lglk
END;


FUNCTION Tckn_est_obj. lata_lglk(
    CONST
      parvec{npar}: ARRAY_1D):
  DOUBLE;
VAR
  i_yr, i_l, i_s, i_a: INTEGER;
  this_pl, sum_pl, this_p_ls, this_p_lsa, sum_p_ls, sum_p_ls_adult,
    inv_sum_p_ls_adult: DOUBLE;

  // from the various unpack_X and set_params
  curipar, i_p, j_p, // i_yr, i_a, i_s, i_l,
    prev_yr, i_y: INTEGER;
  first_result, pp, ipp, mean_l_sa, sd_l_sa, inv_sd_l_sa, scal_min_l, cump_min_l, scal_l,
    inv_tresid_reflen, lgt_tresid_lunder_at_a,
    last_cump, this_cump, slope, this_drm, tot, inv_tot,
    cumul_surv, this_n, nplus_that_will_die,
    pg_new, pg_old,
    this_delta, fupen, sum,
    this_sum_nhat, inv_this_sum_nhat,
    this_sum_nhat_s, inv_this_sum_nhat_s,
    this_rhs, this_tot_fec, tot_n_ysl,
    tot_fec_s, this_fec, inv_tot_fec_s: DOUBLE;

  // from pop_lglk
  this_len, log_p_nomatch, fec_ls, inv_fec_ls, pa_lscad, sum_pa_lscad,
    l_at_jub, this_p_pop, wt_this_fec: DOUBLE;
  i_ju_by, i_a_ycap, i_a_age, age_at_jub, min_comparable_a,
    i_pop, i_ju_pop, i_ad_pop,
    j_y, a_y, a_s, a_l, a_a: INTEGER;
  aclass_a, this_linf: DOUBLE; // from inlining growth_proj2

  i_rct_re: INTEGER;
  temp_exp, re_lglk: DOUBLE;

BEGIN
  // this code inlined temporarily to check AD
  curipar:= 0;
  zero( psurv[ min_ad_yr][ min_ad_a], n_ad_yr_min1 * n_ad_a);
  zero( nhat_ad_sa[ min_ad_yr][ min_sex][ min_ad_a], n_ad_yr * n_sex * n_ad_a);
  zero( tot_mort_y1[ min_sex], n_sex);
  zero( vb_mean_Linf[ min_sex], n_sex);
  zero( vb_k[ min_sex], n_sex);
  zero( vb_t0[ min_sex], n_sex);
  zero( vb_cv_Linf[ min_sex], n_sex);
  zero( tresid[ min_sex][ min_ad_l], n_sex * n_ad_l);
  zero( tresid_under[ min_sex][ min_ad_a], n_sex * n_ad_a);
  zero( inv_tot_fec[ min_jub_yr][ min_sex], n_jub_yr * n_sex);
  zero( fec[ min_sex][ min_ad_l], n_sex * n_ad_l);
  zero( lnfec[ min_sex][ min_ad_l], n_sex * n_ad_l);
  zero( daily_reprod[ male][ min_ad_l], n_ad_l); // not female!

  FOR i_p:= 1 TO npar_surv DO BEGIN
    INCR( curipar);
    FOR i_yr:= min_ad_yr TO max_ad_yr_min1 DO BEGIN
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        INCR( psurv[ i_yr][ i_a], parvec[ curipar] * logit_surv_desmat[ i_yr][ i_a][ i_p]);
      END; // age
    END; // year
  END;  // par

  FOR i_yr:= min_ad_yr TO max_ad_yr_min1 DO BEGIN
    FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
      psurv[ i_yr][ i_a]:= inv_logit( psurv[ i_yr][ i_a]);
    END; // age
  END; // year

  FOR i_p:= 1 TO npar_nsa_y1 DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;

    // Destination will contain log-val; fix later
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        nhat_ad_sa[ min_ad_yr][ i_s][ i_a] +=
            parvec[ curipar] * log_nsa_y1_desmat[ i_s][ i_a][ i_p];
      END; // age
    END; // sex
  END; // par

  // Transform, and set tot_mort_y1[] which is needed for "default" eqm calcs
  // All scaled relative to "historical eqm" at surv rate in first year
  FOR i_s:= min_sex TO max_sex DO BEGIN
    cumul_surv:= 1;
    FOR i_a:= min_ad_a TO max_ad_a-1 DO BEGIN
      this_n:= EXP( nhat_ad_sa[ min_ad_yr][ i_s][ i_a]) * cumul_surv;
      nhat_ad_sa[ min_ad_yr][ i_s][ i_a]:= this_n;
      tot_mort_y1[ i_s] += this_n * (1-psurv[ min_ad_yr][ i_a]);
      cumul_surv *= psurv[ min_ad_yr][ i_a];
    END; // age

    // Nlast = n0*surv^Amax / (1-surv)
    // Of which, (1-surv)*Nlast will die, and contribute to tot_mort_y1
    // So: n_that_will_die is just n0*surv^Amax
    // and calc Nlast from that

    nplus_that_will_die:= EXP( nhat_ad_sa[ min_ad_yr][ i_s][ max_ad_a]) * cumul_surv;
    tot_mort_y1[ i_s] += nplus_that_will_die;
    nhat_ad_sa[ min_ad_yr][ i_s][ max_ad_a]:= nplus_that_will_die / (1-psurv[ min_ad_yr][ max_ad_a]);
  END; // sex

  FOR i_p:= 1 TO npar_nys_a1_reqm DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;

    // Destination will contain log-val; fix later
    FOR i_yr:= min_ad_yr+1 TO max_ad_yr DO BEGIN
      FOR i_s:= min_sex TO max_sex DO BEGIN
        nhat_ad_sa[ i_yr][ i_s][ min_ad_a] +=
            parvec[ curipar] * log_nys_a1_reqm_desmat[ i_yr][ i_s][ i_p];
      END; // sex
    END; // year
  END; // par

  // Transform, and set default rct level
  FOR i_yr:= min_ad_yr+1 TO max_ad_yr DO BEGIN
    FOR i_s:= min_sex TO max_sex DO BEGIN
      nhat_ad_sa[ i_yr][ i_s][ min_ad_a]:= EXP( nhat_ad_sa[ i_yr][ i_s][ min_ad_a]) * tot_mort_y1[ i_s];
    END; // sex
  END; // year

  // REs
  IF n_rct_re>0 THEN BEGIN

    i_rct_re:= 0;
    FOR i_a:= min_ad_a TO max_ad_a-1 DO BEGIN
      INCR( curipar);
      taming[ curipar]:= 0; // tamed "explicitly" elsewhere
      INCR( i_rct_re);
      rct_re[ i_rct_re]:= parvec[ curipar];
      temp_exp:= EXP( rct_re[ i_rct_re]);

      nhat_ad_sa[ min_ad_yr][ female][ i_a] *= temp_exp;
      nhat_ad_sa[ min_ad_yr][ male][ i_a] *= temp_exp;
    END;

    FOR i_yr:= min_ad_yr+1 TO max_ad_yr DO BEGIN
      INCR( curipar);
      taming[ curipar]:= 0; // tamed "explicitly" elsewhere
      INCR( i_rct_re);
      rct_re[ i_rct_re]:= parvec[ curipar];
      temp_exp:= EXP( rct_re[ i_rct_re]);

      nhat_ad_sa[ i_yr][ female][ min_ad_a] *= temp_exp;
      nhat_ad_sa[ i_yr][ male][ min_ad_a] *= temp_exp;
    END;
  END;

  FOR i_yr:= min_ad_yr+1 TO max_ad_yr DO BEGIN
    prev_yr:= i_yr-1;
    {LOOPOPTIM prev_yr}
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_a:= min_ad_a+1 TO max_ad_a DO BEGIN
        nhat_ad_sa[ i_yr][ i_s][ i_a]:= nhat_ad_sa[ prev_yr][ i_s][ i_a-1] * psurv[ prev_yr][ i_a-1];
      END; // age

      // Plus-group
      pg_new:= nhat_ad_sa[ i_yr][ i_s][ max_ad_a];
      pg_old:= nhat_ad_sa[ prev_yr][ i_s][ max_ad_a] * psurv[ prev_yr][ max_ad_a];

      // ... Update mean age
      // Incoming PG is at XS=0, so 0*them can be omitted
      mean_xs_pg_a[ i_yr][ i_s]:= (( mean_xs_pg_a[ prev_yr][ i_s]+1) * pg_old) / (pg_old+pg_new);

      // ... and add survivors from previous plus-group
      nhat_ad_sa[ i_yr][ i_s][ max_ad_a] += pg_old;
    END; // sex
  END; // yr

  FOR i_yr:= min_ad_yr TO max_ad_yr DO BEGIN
    this_sum_nhat:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      this_sum_nhat_s:= 0;
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        this_sum_nhat_s += nhat_ad_sa[ i_yr][ i_s][ i_a];
      END; // age
      this_sum_nhat += this_sum_nhat_s;

      inv_this_sum_nhat_s:= 1/this_sum_nhat_s;
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        phat_a_given_s[ i_yr][ i_s][ i_a]:= nhat_ad_sa[ i_yr][ i_s][ i_a] * inv_this_sum_nhat_s;
      END; // age
    END; // sex

    // Now ppn by sex & age
    inv_this_sum_nhat:= 1/this_sum_nhat;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        phat_ad_sa[ i_yr][ i_s][ i_a]:= nhat_ad_sa[ i_yr][ i_s][ i_a] * inv_this_sum_nhat;
      END; // age
    END; // sex
  END; // year


  // Growth
  FOR i_p:= 1 TO npar_vb_mean_Linf DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      vb_mean_Linf[ i_s] += parvec[ curipar] * log_vb_mean_Linf_desmat[ i_s][ i_p];
    END;
  END;

  FOR i_p:= 1 TO npar_vb_k DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      vb_k[ i_s] += parvec[ curipar] * log_vb_k_desmat[ i_s][ i_p];
    END;
  END;

  FOR i_p:= 1 TO npar_vb_t0 DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      vb_t0[ i_s] += parvec[ curipar] * I_vb_t0_desmat[ i_s][ i_p];
    END;
  END;

  FOR i_p:= 1 TO npar_vb_cv_Linf DO BEGIN
    INCR( curipar);
    FOR i_s:= min_sex TO max_sex DO BEGIN
      vb_cv_Linf[ i_s] += parvec[ curipar] * log_vb_cv_Linf_desmat[ i_s][ i_p];
    END;
  END;

  // Transform...
  FOR i_s:= min_sex TO max_sex DO BEGIN
    vb_mean_Linf[ i_s]:= EXP( vb_mean_Linf[ i_s]);
    vb_k[ i_s]:= EXP( vb_k[ i_s]);
    // t0 can be +ve or -ve; no tmfn reqd
    vb_cv_Linf[ i_s]:= EXP( vb_cv_Linf[ i_s]);
  END;

  // ... and compute entire growth dsn
  FOR i_s:= min_sex TO max_sex DO BEGIN
    FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
      mean_l_sa:= vb_mean_Linf[ i_s] * (1 - exp( -vb_k[ i_s] * (i_a - vb_t0[ i_s])));
      sd_l_sa:= mean_l_sa * vb_cv_Linf[ i_s];
      inv_sd_l_sa:= 1/sd_l_sa;
      scal_min_l:= (min_ad_l - 0.5 - mean_l_sa) * inv_sd_l_sa;

      // Undersized fish need a ppn, and a mean size from truncated distro
      cump_min_l:= pt_nueveni( scal_min_l, t_or_norm);
      lunder[ i_s][ i_a]:= mean_l_sa + sd_l_sa *
          mean_t_nueveni_trunclt( scal_min_l, cump_min_l, t_or_norm);
      punder[ i_s][ i_a]:= cump_min_l;

      // No "minus-group"!
      last_cump:= cump_min_l;
      FOR i_l:= min_ad_l TO max_ad_l-1 DO BEGIN
        // Do on separate line to avoid complic deriv and FU in AD-R with var/const
        scal_l:= (i_l + 0.5 - mean_l_sa) * inv_sd_l_sa;
        this_cump:= pt_nueveni( scal_l, t_or_norm);
        pl_sa[ i_s][ i_l][ i_a]:= this_cump - last_cump;
        last_cump:= this_cump;
      END; // length
      pl_sa[ i_s][  max_ad_l][ i_a]:= 1 - last_cump;

    END; // age
  END; // sex

  FOR i_p:= 1 TO npar_tresid DO BEGIN
    INCR( curipar);
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        INCR( tresid[ i_s][ i_l], parvec[ curipar] * logit_tresid_desmat[ i_s][ i_l][ i_p]);
      END; // length
    END; // sex
  END; // par

  inv_tresid_reflen:= 1/inv_logit( tresid[ min_sex][ i_reflen]); // norm sexes jointly not separately
  FOR i_s:= min_sex TO max_sex DO BEGIN
    // Undersize: use a nasty fudge. Don't want to bother with cuspline etc
    // ... so take logit-linear extrapolation over two lowest Lclasses
    // ... back to lunder (the mean)
    // Must do undersize-at-age first, before tresid itself gets inverse-logitted
    slope:= tresid[ i_s][ min_ad_l+1] - tresid[ i_s][ min_ad_l];
    FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
      lgt_tresid_lunder_at_a:= tresid[ i_s][ min_ad_l] + slope * (lunder[ i_s][ i_a] - min_ad_l);
      tresid_under[ i_s][ i_a]:= inv_tresid_reflen * inv_logit( lgt_tresid_lunder_at_a);
    END;

    // Now can do length
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      tresid[ i_s][ i_l]:= inv_tresid_reflen * inv_logit( tresid[ i_s][ i_l]);
    END; // length
  END; // sex

  // Those goddam males
  FOR i_p:= 1 TO npar_daily_reprodm DO BEGIN
    INCR( curipar);
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      INCR( daily_reprod[ male][ i_l], parvec[ curipar] * log_daily_reprodm_desmat[ i_l][ i_p]);
    END; // length
  END; // par

  tot:= 0;
  FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
    this_drm:= EXP( daily_reprod[ male][ i_l]);
    daily_reprod[ male][ i_l]:= this_drm;
    tot += this_drm;
  END; // length

  inv_tot:= 1/tot;
  FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
    daily_reprod[ male][ i_l] *= inv_tot;
  END; // length

  // Finally: female fec and fec unc, if required
  FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
    log_daily_reprodf[ i_l]:= base_log_daily_reprodf[ i_l];
  END;

  FOR i_p:= 1 TO npar_fec_unc DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;
    this_delta:= parvec[ curipar];
    delta_fec_unc[ i_p]:= this_delta;
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      log_daily_reprodf[ i_l] += this_delta * fec_unc_desmat[ i_l][ i_p];
    END;
  END;

  FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
    daily_reprod[ female][ i_l]:= EXP( log_daily_reprodf[ i_l]);
  END;

  // set_fec();
  FOR i_s:= min_sex TO max_sex DO BEGIN
    tot_fec_s:= 0;
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      this_fec:= daily_reprod[ i_s][ i_l] * tresid[ i_s][ i_l]; // used by set_tot_fec
      fec[ i_s][ i_l]:= this_fec;
      tot_fec_s += this_fec;
    END;

    inv_tot_fec_s:= 1/tot_fec_s;
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      fec[ i_s][ i_l] *= inv_tot_fec_s;
      lnfec[ i_s][ i_l]:= LN( fec[ i_s][ i_l]);
    END;

    // From NumRecip 1986, sec 3.3, p88-89; simplified for DeltaX==1
    spl_y2[ i_s][ min_ad_l]:= 0;
    spl_u[ min_ad_l]:= 0; // spl_u is temp wkspace, not needed by sex
    FOR i_l:= min_ad_l+1 TO max_ad_l-1 DO BEGIN
      // sig:= 0.5
      pp:= 0.5*spl_y2[ i_s][ i_l-1]+2;
      ipp:= 1/pp;
      spl_y2[ i_s][ i_l]:= -0.5 * ipp;
      this_rhs:= lnfec[ i_s][i_l+1] - 2*lnfec[ i_s][ i_l] + lnfec[ i_s][ i_l-1];
      spl_u[i_l]:= (3*this_rhs - 0.5*spl_u[ i_l-1]) * ipp;
    END;

    spl_y2[ i_s][ max_ad_l]:= 0; // un==0, qn==0 => y2[n] = (un*...+qn*...)/... == 0
    FOR i_l:= max_ad_l-1 DOWNTO min_ad_l DO BEGIN
      spl_y2[ i_s][ i_l]*= spl_y2[ i_s][ i_l+1] + spl_u[ i_l];
    END;

    FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
      fec_under[ i_s][ i_a]:= fec_fn( i_s, lunder[ i_s][ i_a]);
    END;
  END;

  // Total fec by year needs to wait

  RESULT:= 0;
  FOR curipar:= 1 TO npar DO BEGIN // taming[] excludes N-params
    RESULT -= tamer * taming[ curipar] * SQR( parvec[ curipar]);
  END;

  zero( pls_pres_ysl[ min_ad_yr][ min_sex][ min_ad_l], n_ad_yr*n_sex*n_ad_l);
  zero( pls_adult_ysl[ min_ad_yr][ min_sex][ min_ad_l], n_ad_yr*n_sex*n_ad_l);

  // Everything is conditional on capture...
  // Want P[l|as] to be "pure" ie in population

  // P[as|l,cap] = P[l,cap|as] P[as] / P[l,cap] = P[cap|l{as}] P[l|as] P[as] / P[l,cap]
  // = P[cap|l] P[l|as] P[as] / P[l,cap]
  // P[l,cap] = P[ cap|l] sum_AS( P[l|AS] P[AS])
  // sum_as( n_as_l ln( P[ as|l])) = sum_as( n_as_l ln( P[l_as] P[as])) - sum_as (n_as_l) * ln( P[ l])
  // P[cap|l] = tresid[ i_l] or qsel[ i_l]

  // With length AND sex: sum across BOTH should be 1
  FOR i_yr:= min_ad_yr TO max_ad_yr DO BEGIN
    sum_p_ls:= 0; // for LS-freq of unknown-age fish, incl some subadults
    sum_p_ls_adult:= 0; // needed for fec calcs
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        // Could take the tresid/qsel mult out of this loop
        this_p_ls:= 0;
        FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
          this_p_lsa:= tresid[ i_s][ i_l] * pl_sa[ i_s][ i_l][ i_a] * phat_ad_sa[ i_yr][ i_s][ i_a];
          this_p_ls += this_p_lsa;
          RESULT += n_log_p( rs_a_given_ls[ i_yr][ i_s][ i_l][ i_a], this_p_lsa);
        END; // i_a
        RESULT -= n_log_p( tot_rs_a_given_ls[ i_yr][ i_s][ i_l], this_p_ls);

        pls_adult_ysl[ i_yr][ i_s][ i_l]:= this_p_ls;
        sum_p_ls_adult += this_p_ls;

        // Compo for too-young fish that we'd ideally exclude from LF
        this_p_ls:= this_p_ls * pls_adjustor[ i_yr][ i_s][ i_l];
        pls_pres_ysl[ i_yr][ i_s][ i_l]:= this_p_ls;
        RESULT += n_log_p( rs_ls[ i_yr][ i_s][ i_l], this_p_ls);
        sum_p_ls += this_p_ls;
      END; // i_l
    END; // i_s

    // Norm for fish in LRANGE:
    RESULT -= n_log_p( tot_rs_ls[ i_yr], sum_p_ls);

    // Just with length:
    IF tot_rs_l_nos[ i_yr] > 0 THEN BEGIN
      sum_pl:= 0;
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        this_pl:= pls_pres_ysl[ i_yr][ male][ i_l] + pls_pres_ysl[ i_yr][ female][ i_l];
        sum_pl += this_pl;
        RESULT += n_log_p( rs_l_nos[ i_yr][ i_l], this_pl);
      END;

      // Norm for fish in LRANGE:
      RESULT -= n_log_p( tot_rs_l_nos[ i_yr], sum_pl);
    END;

    // Now stuff for p_pop_no_ls in pop_lglk()
    // First, P[sl|undersize]
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        this_p_lsa:= tresid_under[ i_s][ i_a] * punder[ i_s][ i_a] * phat_ad_sa[ i_yr][ i_s][ i_a];
        punder_pres_ysa[ i_yr][ i_s][ i_a]:= this_p_lsa;
        sum_p_ls_adult += this_p_lsa;
      END; // i_a
    END; // i_s

    // Last, norm across *all* fish-on-grounds, not just those in LRANGE
    inv_sum_p_ls_adult:= 1/sum_p_ls_adult;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        pls_adult_ysl[ i_yr][ i_s][ i_l] *= inv_sum_p_ls_adult;
      END; // i_l

      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        punder_pres_ysa[ i_yr][ i_s][ i_a] *= inv_sum_p_ls_adult;
      END;
    END; // i_s
  END; // i_yr

  first_result:= RESULT;

  //set_tot_fec();
  // Can't be done before the ALS calcs because it requires punder_pres_ysa
  FOR i_y:= min_jub_yr TO max_jub_yr DO BEGIN
    FOR i_s:= min_sex TO max_sex DO BEGIN
      this_tot_fec:= 0;

      // Contrib from OK-size
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        tot_n_ysl:= 0;
        FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
          tot_n_ysl += nhat_ad_sa[ i_y][ i_s][ i_a] * pl_sa[ i_s][ i_l][ i_a];
        END;

        this_tot_fec += tot_n_ysl * fec[ i_s][ i_l];
      END; // i_l

      // Contrib from undersized: mean_fec_undersize depends on age
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        this_tot_fec += nhat_ad_sa[ i_y][ i_s][ i_a]
          * punder_pres_ysa[ i_y][ i_s][ i_a]
          * fec_under[ i_s][ i_a];
        // mean_fec_undersize[] = fec_fn( i_s, mean_l_undersize[i_s][i_a]
      END; // i_a

      inv_tot_fec[ i_y][ i_s]:= 1/this_tot_fec;
    END; // sex
  END; // year

  // pop_lglk() inlined here:

  // Not really necessary to store all of p_a_lspop:
  // More efficient, at least for storage: p_a_lspop should be array across POPs only,
  // and repeat this code in a loop over POPs and age (not over juby, ycap, sex, len, and age)
  // Modest number of repeat-calcs needed

  zero( p_a_lspop[ min_jub_yr][ min_ad_yr][ min_sex][ min_ad_l][ min_ad_a],
      n_jub_yr * n_ad_yr * n_sex * n_ad_l * n_ad_a);
  zero( p_pop_no_ls[ min_jub_yr][ min_ad_yr], n_jub_yr * n_ad_yr);
  zero( expect_pops_no_ls[ min_jub_yr][ min_ad_yr], n_jub_yr * n_ad_yr);
  zero( expect_pops_ls[ min_jub_yr][ min_ad_yr][ min_sex][ min_ad_l],
      n_jub_yr * n_ad_yr * n_sex * n_ad_l); // diagnostic really

  // Assume no POPs at all, then fix up lglk for the few cases where there is
  log_p_nomatch:= 0;
  FOR i_ju_by:= min_jub_yr TO max_jub_yr DO BEGIN
    // Total fec that year already computed

    // Adult loops: what is P[j~i] (j juve, i adult) for juby, acap, alen? And if j~i, what is P[age=a|j~i, acap, alen]?
    // NB no conditioning on age for non-POPs; lots of comps, so age is propto general age-at-len
    FOR i_a_ycap:= min_jub_yr+1 TO max_ad_yr DO BEGIN // year of CAPTURE
      min_comparable_a:= min_ad_a + i_a_ycap - i_ju_by;

      FOR i_s:= min_sex TO max_sex DO BEGIN
        FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
          // Work out mean fec for this l at juby
          fec_ls:= 0;
          this_len:= i_l; // double required for some calls
          sum_pa_lscad:= 0;

          FOR i_a_age:= min_comparable_a TO max_ad_a DO BEGIN
            age_at_jub:= i_a_age - (i_a_ycap - i_ju_by);

            // phat_a_given_s is only adults; underage are adjusted-out after the loop
            pa_lscad:= pl_sa[ i_s][ i_l][ i_a_age] * phat_a_given_s[ i_a_ycap][ i_s][ i_a_age];
            sum_pa_lscad += pa_lscad;

            // Next line: ADR can't cope with one_if[] yet
            aclass_a:= i_a_age; // + one_if[i_a_age=max_ad_a] * mean_xs_pg_a[i_a_ycap][i_s];
            IF i_a_age=max_ad_a THEN BEGIN
              aclass_a += mean_xs_pg_a[i_a_ycap][i_s];
            END;

            // l_at_jub:= growth_proj( i_s, this_len, i_a_age, age_at_jub); // this_len DOUBLE NOT INTEGER so AD works
            // l_at_jub:= growth_proj2( vb_k[ i_s], vb_t0[ i_s], this_len, i_a_age, age_at_jub); // this_len DOUBLE NOT INTEGER so AD works
            this_linf:= this_len / (1 - EXP( -vb_k[i_s] * (aclass_a - vb_t0[i_s]))); // was i_a
            l_at_jub:= this_linf * (1 - EXP( -vb_k[i_s] * (age_at_jub - vb_t0[i_s])));

            wt_this_fec:= fec_fn( i_s, l_at_jub) * pa_lscad; // fec needs to be a 2ND-ORDER-SMOOTH fn of len eg a cubic interpolant
            p_a_lspop[ i_ju_by][ i_a_ycap][ i_s][ i_l][ i_a_age]:= wt_this_fec;
            fec_ls += wt_this_fec;
          END; // adult age (unknown)

          // Temporary normalizer for p_a_lspop
          inv_fec_ls:= 1/fec_ls;
          FOR i_a_age:= min_comparable_a TO max_ad_a DO BEGIN
            p_a_lspop[ i_ju_by][ i_a_ycap][ i_s][ i_l][ i_a_age] *= inv_fec_ls;
          END;

          // Proper normalizer: have wtd sum over age, need wtd mean!
          fec_ls /= sum_pa_lscad;
          // Cut out underage-- this "really" applies to phat_a_given_s above
          fec_ls *= inv_pls_adjustor[ i_a_ycap][ i_s][ i_l];

          // Just for diagnostics: fec_ls shouldn't be soooo different from fec[s][l]
          // ... but should gradually decline with bigger dist between ycap & juby
          keep_fec_ls[ i_ju_by][ i_a_ycap][ i_s][ i_l]:= fec_ls;

          // N enters here, via inv_tot_fec:
          this_p_pop:= fec_ls * inv_tot_fec[ i_ju_by][ i_s];
          p_pop_ls[ i_ju_by][ i_a_ycap][ i_s][ i_l]:= this_p_pop;
          log_p_nomatch += n_pcomps_ls[ i_ju_by][ i_a_ycap][ i_s][ i_l] * log1p( -this_p_pop);
          expect_pops_ls[ i_ju_by][ i_a_ycap][ i_s][ i_l] +=
            n_pcomps_ls[ i_ju_by][ i_a_ycap][ i_s][ i_l] * this_p_pop;

          p_pop_no_ls[ i_ju_by][ i_a_ycap] += this_p_pop * pls_adult_ysl[ i_a_ycap][i_s][ i_l];
        END; // adult length (known)

        // Genoed fish with unknown LS _might_ be undersized even now, and could have been POPs
        // ... unlikely but let's keep it tight
        FOR i_a_age:= min_comparable_a TO max_ad_a DO BEGIN
          age_at_jub:= i_a_age - (i_a_ycap - i_ju_by);
          {$IFNDEF AD}
          IF age_at_jub < min_ad_a THEN BEGIN // should NEVER happen thx2 min_comparable_a
            RESULT:= QNAN;
EXIT;
          END;
          {$ENDIF}{AD}
          this_len:= lunder[ i_s][ age_at_jub];
          // l_at_jub:= growth_proj( i_s, this_len, i_a_age, age_at_jub);
          // l_at_jub:= growth_proj2( vb_k[ i_s], vb_t0[ i_s], this_len, i_a_age, age_at_jub);
          this_linf:= this_len / (1 - EXP( -vb_k[i_s] * (i_a_age - vb_t0[i_s])));
          l_at_jub:= this_linf * (1 - EXP( -vb_k[i_s] * (age_at_jub - vb_t0[i_s])));
          wt_this_fec:= punder_pres_ysa[ i_a_ycap][ i_s][ i_a_age] * fec_fn( i_s, l_at_jub);
          p_pop_no_ls[ i_ju_by][ i_a_ycap] += wt_this_fec * inv_tot_fec[ i_ju_by][ i_s];
        END;
      END; // sex (known)

      // Missing length/sex:
      log_p_nomatch += n_pcomps_no_ls[ i_ju_by][ i_a_ycap] * log1p( -p_pop_no_ls[ i_ju_by][ i_a_ycap]);
      expect_pops_no_ls[ i_ju_by][ i_a_ycap] += n_pcomps_no_ls[ i_ju_by][ i_a_ycap] *
        p_pop_no_ls[ i_ju_by][ i_a_ycap];
    END; // ad cap year
  END; // ju birth year

  RESULT+= log_p_nomatch; // note the plus-equal; pop_lglk() of course just has becomes-equal

  // Above calcs assume NO pops! Now fix up the lglk for the cases where there _is_ a POP
  // Almost all: we do know adult len
  FOR i_pop:= 1 TO n_pop_als DO BEGIN
    i_ju_pop:= ju_pop_als[ i_pop];
    i_ad_pop:= ad_pop_als[ i_pop];
    j_y:= ju_by[ i_ju_pop];
    a_y:= ad_ycap[ i_ad_pop];
    a_s:= ad_sex[ i_ad_pop];
    a_l:= ad_len[ i_ad_pop];
    a_a:= ad_age[ i_ad_pop];

    {$IFNDEF AD}
    IF a_y <= j_y THEN BEGIN
      RESULT:= QNAN;
EXIT;
    END;
    IF a_a - (a_y - j_y) < min_ad_a THEN BEGIN
      RESULT:= QNAN;
EXIT;
    END;
    {$ENDIF}{AD}

    RESULT += logit( p_pop_ls[ j_y][ a_y][ a_s][ a_l]);

    // Also need P[a|ls, pop]
    RESULT += LN( p_a_lspop[ j_y][ a_y][ a_s][ a_l][ a_a]);
  END; // pops with known a&l&s

  // Rare: unknown-length-sex POPs (eg identified mixup, or sensitivity to outliers)
  FOR i_pop:= 1 TO n_pop_no_als DO BEGIN
    i_ju_pop:= ju_pop_no_als[ i_pop];
    i_ad_pop:= ad_pop_no_als[ i_pop];
    RESULT += logit( p_pop_no_ls[ ju_by[ i_ju_pop]][ ad_ycap[ i_ad_pop]]);
  END; // POPs with unknown a|l|s

  IF rct_is_re>0 THEN BEGIN
    re_lglk:= 0;
    FOR i_rct_re:= 1 TO n_rct_re DO BEGIN
      re_lglk -= SQR( rct_re[ i_rct_re]);
    END;

    re_lglk /= (2*rct_re_var);

    // And the prior bit... cf lodis where this is added in R
    re_lglk -= 0.5 * n_rct_re * log_rct_re_var;

    RESULT += re_lglk;
  END;

  // Fec uncert penalty
  fupen:= 0;
  FOR i_p:= 1 TO npar_fec_unc DO BEGIN
    sum:= 0;
    FOR j_p:= 1 TO npar_fec_unc DO BEGIN
      sum += fec_unc_penmat[ i_p][ j_p] * delta_fec_unc[ j_p];
    END;
    fupen += sum * delta_fec_unc[ i_p];
  END;

  RESULT -= 0.5 * fupen;
END;


FUNCTION Tckn_est_obj. pop_lglk():
  DOUBLE;
VAR
  this_len, log_p_nomatch, fec_ls, inv_fec_ls, pa_ls, l_at_jub, this_p_pop, wt_this_fec: DOUBLE;
  i_ju_by, i_s, i_a_ycap, i_l, i_a_age, aclass_a, age_at_jub, min_comparable_a,
    i_pop, i_ju_pop, i_ad_pop,
    j_y, a_y, a_s, a_l, a_a: INTEGER;
BEGIN
 // CODE MOVED TO LATA_LGLK FOR NOW-- CULLED HERE TO AVOID DUPLICATION ERRORS!
END;

PROCEDURE Tckn_est_obj. set_tot_fec();
VAR
  i_y, i_s, i_a, i_l: INTEGER;
  tot_n_ysl, this_tot_fec: DOUBLE;
BEGIN
  FOR i_y:= min_jub_yr TO max_jub_yr DO BEGIN
    FOR i_s:= min_sex TO max_sex DO BEGIN
      this_tot_fec:= 0;

      // Contrib from OK-size
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        tot_n_ysl:= 0;
        FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
          tot_n_ysl += nhat_ad_sa[ i_y][ i_s][ i_a] * pl_sa[ i_s][ i_l][ i_a];
        END;

        this_tot_fec += tot_n_ysl * fec[ i_s][ i_l];
      END; // i_l

      // Contrib from undersized: mean_fec_undersize depends on age
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        this_tot_fec += nhat_ad_sa[ i_y][ i_s][ i_a]
          * punder_pres_ysa[ i_y][ i_s][ i_a]
          * fec_under[ i_s][ i_a];
        // mean_fec_undersize[] = fec_fn( i_s, mean_l_undersize[i_s][i_a]
      END; // i_a

      inv_tot_fec[ i_y][ i_s]:= 1/this_tot_fec;
    END; // sex
  END; // year
END;

PROCEDURE Tckn_est_obj. set_fec();
VAR
  i_s, i_l, i_a: INTEGER;
  this_rhs, tot_fec_s, inv_tot_fec_s, this_fec, pp, ipp: DOUBLE;
BEGIN
  FOR i_s:= min_sex TO max_sex DO BEGIN
    tot_fec_s:= 0;
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      this_fec:= daily_reprod[ i_s][ i_l] * tresid[ i_s][ i_l]; // used by set_tot_fec
      fec[ i_s][ i_l]:= this_fec;
      tot_fec_s += this_fec;
    END;

    inv_tot_fec_s:= 1/tot_fec_s;
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      fec[ i_s][ i_l] *= inv_tot_fec_s;
      lnfec[ i_s][ i_l]:= LN( fec[ i_s][ i_l]);
    END;

    // From NumRecip 1986, sec 3.3, p88-89; simplified for DeltaX==1
    spl_y2[ i_s][ min_ad_l]:= 0;
    spl_u[ min_ad_l]:= 0; // spl_u is temp wkspace, not needed by sex
    FOR i_l:= min_ad_l+1 TO max_ad_l-1 DO BEGIN
      // sig:= 0.5
      pp:= 0.5*spl_y2[ i_s][ i_l-1]+2;
      ipp:= 1/pp;
      spl_y2[ i_s][ i_l]:= -0.5 * ipp;
      this_rhs:= lnfec[ i_s][i_l+1] - 2*lnfec[ i_s][ i_l] + lnfec[ i_s][ i_l-1];
      spl_u[i_l]:= (3*this_rhs - 0.5*spl_u[ i_l-1]) * ipp;
    END;

    spl_y2[ i_s][ max_ad_l]:= 0; // un==0, qn==0 => y2[n] = (un*...+qn*...)/... == 0
    FOR i_l:= max_ad_l-1 DOWNTO min_ad_l DO BEGIN
      spl_y2[ i_s][ i_l] *= spl_y2[ i_s][ i_l+1] + spl_u[ i_l];
    END;

    FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
      fec_under[ i_s][ i_a]:= fec_fn( i_s, lunder[ i_s][ i_a]);
    END;
  END;

  set_tot_fec();
END;

FUNCTION Tckn_est_obj. fec_fn(
    CONST
      sex: INTEGER;
    CONST
      len: DOUBLE):
  DOUBLE;
VAR
  y, a, b: DOUBLE;
  ilo, ihi: INTEGER;
BEGIN
  // Natural cubic spline extrap:
  IF len <= min_ad_l THEN BEGIN
    y:= lnfec[ sex][ min_ad_l] +
      (lnfec[ sex][ min_ad_l+1] - lnfec[ sex][ min_ad_l] - spl_y2[ sex][ min_ad_l+1] * (1/6)) *
      (len-min_ad_l);
  END ELSE IF len >= max_ad_l THEN BEGIN
    y:= lnfec[ sex][ max_ad_l] +
      (lnfec[ sex][ max_ad_l] - lnfec[ sex][ max_ad_l-1] + spl_y2[ sex][ max_ad_l-1] * (1/6)) *
      (len-max_ad_l);
  END ELSE BEGIN
    ilo:= TRUNC( len);
    ihi:= ilo+1;

    a:= ihi-len;
    b:= len-ilo;
    y:= a*lnfec[ sex][ ilo] + b*lnfec[ sex][ ihi] +
      (1/6) * (a*(SQR(a)-1)*spl_y2[ sex][ ilo] + b*(SQR(b)-1)*spl_y2[ sex][ ihi]);
  END;

  RESULT:= EXP( y);
END;

FUNCTION Tckn_est_obj. growth_proj(
  CONST
    sex: INTEGER;
  CONST
    curl: DOUBLE;
  CONST
    cura, newa: INTEGER):
  DOUBLE;
VAR
  my_linf: DOUBLE;
BEGIN
  my_linf:= curl / (1 - EXP( -vb_k[ sex] * (cura - vb_t0[ sex])));
  RESULT:= my_linf * (1 - EXP( -vb_k[ sex] * (newa - vb_t0[ sex])));
END;

FUNCTION Tckn_est_obj. growth_proj2(
  CONST
    k, t0, curl: DOUBLE;
  CONST
    cura, newa: INTEGER):
  DOUBLE;
VAR
  my_linf: DOUBLE;
BEGIN
  my_linf:= curl / (1 - EXP( -k * (cura - t0)));
  RESULT:= my_linf * (1 - EXP( -k * (newa - t0)));
END;


PROCEDURE Tckn_est_obj. set_params(
    CONST
      parvec{npar}: ARRAY_1D);
BEGIN
  // Approach is deliberately formulaic
  // For each "type" of parameter-driven entity:
  // 1. apply desmat to each block of params, one "row" per combo of age/sex/yr etc;
  // 2. then transform / expand if reqd

  curipar:= 0;
  zero( psurv[ min_ad_yr][ min_ad_a], n_ad_yr_min1 * n_ad_a);
  zero( nhat_ad_sa[ min_ad_yr][ min_sex][ min_ad_a], n_ad_yr * n_sex * n_ad_a);
  zero( tot_mort_y1[ min_sex], n_sex);
  zero( vb_mean_Linf[ min_sex], n_sex);
  zero( vb_k[ min_sex], n_sex);
  zero( vb_t0[ min_sex], n_sex);
  zero( vb_cv_Linf[ min_sex], n_sex);
  zero( tresid[ min_sex][ min_ad_l], n_sex * n_ad_l);
  zero( tresid_under[ min_sex][ min_ad_a], n_sex * n_ad_a);
  zero( inv_tot_fec[ min_jub_yr][ min_sex], n_jub_yr * n_sex);
  zero( fec[ min_sex][ min_ad_l], n_sex * n_ad_l);
  zero( lnfec[ min_sex][ min_ad_l], n_sex * n_ad_l);
  zero( fec[ min_sex][ min_ad_l], min_ad_l * n_ad_l);
  zero( daily_reprod[ male][ min_ad_l], n_ad_l); // not female!

  unpack_surv( parvec); // surv before n_yr1, since former is needed by latter
  unpack_nsa_y1( parvec); // n_yr1 before nys_a1_reqm which needs n_yr1 & surv
  unpack_nys_a1_reqm( parvec);
  propagate_n();
  unpack_growth( parvec);
  unpack_tresid( parvec);
  unpack_male_daily_reprod( parvec);
  set_fec();

 {$IFNDEF AD}
  IF curipar <> npar THEN BEGIN
    parvec[1]:= QNAN;
    // ShowMessage( 'Errk!!');
  END;
  {$ENDIF}{AD}
END;

PROCEDURE Tckn_est_obj. unpack_nsa_y1(
  CONST parvec{npar}: ARRAY_1D);
VAR
  i_p, i_s, i_a: INTEGER;
  this_n, cumul_surv, nplus_that_will_die: DOUBLE;
BEGIN
  // Default is eqm, so numbers decline according to psurv, with bump on plus-group
  // Terms in desmat cause deviation from this
  FOR i_p:= 1 TO npar_nsa_y1 DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0; // no penalty

    // Destination will contain log-val; fix later
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        nhat_ad_sa[ min_ad_yr][ i_s][ i_a] +=
            parvec[ curipar] * log_nsa_y1_desmat[ i_s][ i_a][ i_p];
      END; // age
    END; // sex
  END; // par

  // Transform, and set tot_mort_y1[] which is needed for "default" eqm calcs
  // All scaled relative to "historical eqm" at surv rate in first year
  FOR i_s:= min_sex TO max_sex DO BEGIN
    cumul_surv:= 1;
    FOR i_a:= min_ad_a TO max_ad_a-1 DO BEGIN
      this_n:= EXP( nhat_ad_sa[ min_ad_yr][ i_s][ i_a]) * cumul_surv;
      nhat_ad_sa[ min_ad_yr][ i_s][ i_a]:= this_n;
      tot_mort_y1[ i_s] += this_n * (1-psurv[ min_ad_yr][ i_a]);
      cumul_surv *= psurv[ min_ad_yr][ i_a];
    END; // age

    // Nlast = n0*surv^Amax / (1-surv)
    // Of which, (1-surv)*Nlast will die, and contribute to tot_mort_y1
    // So: n_that_will_die is just n0*surv^Amax
    // and calc Nlast from that

    nplus_that_will_die:= EXP( nhat_ad_sa[ min_ad_yr][ i_s][ max_ad_a]) * cumul_surv;
    tot_mort_y1[ i_s] += nplus_that_will_die;
    nhat_ad_sa[ min_ad_yr][ i_s][ max_ad_a]:= nplus_that_will_die / (1-psurv[ min_ad_yr][ max_ad_a]);
  END; // sex
END;

PROCEDURE Tckn_est_obj. unpack_nys_a1_reqm(
  CONST parvec{npar}: ARRAY_1D);
VAR
  i_p, i_s, i_yr: INTEGER;
BEGIN
  FOR i_p:= 1 TO npar_nys_a1_reqm DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0; // no penalty

    // Destination will contain log-val; fix later
    FOR i_yr:= min_ad_yr+1 TO max_ad_yr DO BEGIN
      FOR i_s:= min_sex TO max_sex DO BEGIN
        nhat_ad_sa[ i_yr][ i_s][ min_ad_a] +=
            parvec[ curipar] * log_nys_a1_reqm_desmat[ i_yr][ i_s][ i_p];
      END; // sex
    END; // year
  END; // par

  // Transform...
  FOR i_yr:= min_ad_yr+1 TO max_ad_yr DO BEGIN
    FOR i_s:= min_sex TO max_sex DO BEGIN
      nhat_ad_sa[ i_yr][ i_s][ min_ad_a]:= EXP( nhat_ad_sa[ i_yr][ i_s][ min_ad_a]) * tot_mort_y1[ i_s];
    END; // sex
  END; // year
END;

PROCEDURE Tckn_est_obj. unpack_surv(
  CONST parvec{npar}: ARRAY_1D);
VAR
  i_p, i_yr, i_a: INTEGER;
BEGIN
  // Destination will contain logit-val; fix later
  FOR i_p:= 1 TO npar_surv DO BEGIN
    INCR( curipar);
    FOR i_yr:= min_ad_yr TO max_ad_yr_min1 DO BEGIN
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        INCR( psurv[ i_yr][ i_a], parvec[ curipar] * logit_surv_desmat[ i_yr][ i_a][ i_p]);
      END; // age
    END; // year
  END;  // par

  FOR i_yr:= min_ad_yr TO max_ad_yr_min1 DO BEGIN
    FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
      psurv[ i_yr][ i_a]:= inv_logit( psurv[ i_yr][ i_a]);
    END; // age
  END; // year
END;

PROCEDURE Tckn_est_obj. propagate_n();
VAR
  i_yr, prev_yr, i_s, i_a: INTEGER;
  this_sum_nhat_s, inv_this_sum_nhat_s,
    this_sum_nhat, inv_this_sum_nhat: DOUBLE;
BEGIN
  // phat is Pr[ sex AND age GIVEN year] not Pr[ age GIVEN sex AND year] so need year-loop outside
  FOR i_yr:= min_ad_yr+1 TO max_ad_yr DO BEGIN
    prev_yr:= i_yr-1;
    {LOOPOPTIM prev_yr}
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_a:= min_ad_a+1 TO max_ad_a DO BEGIN
        nhat_ad_sa[ i_yr][ i_s][ i_a]:= nhat_ad_sa[ prev_yr][ i_s][ i_a-1] * psurv[ prev_yr][ i_a-1];
      END; // age

      // Plus-group: add survivors from previous plus-group
      nhat_ad_sa[ i_yr][ i_s][ max_ad_a] += nhat_ad_sa[ prev_yr][ i_s][ max_ad_a] * psurv[ prev_yr][ max_ad_a];
    END; // sex
  END; // yr

  FOR i_yr:= min_ad_yr TO max_ad_yr DO BEGIN
    this_sum_nhat:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      this_sum_nhat_s:= 0;
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        this_sum_nhat_s += nhat_ad_sa[ i_yr][ i_s][ i_a];
      END; // age
      this_sum_nhat += this_sum_nhat_s;

      inv_this_sum_nhat_s:= 1/this_sum_nhat_s;
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        phat_a_given_s[ i_yr][ i_s][ i_a]:= nhat_ad_sa[ i_yr][ i_s][ i_a] * inv_this_sum_nhat_s;
      END; // age
    END; // sex

    // Now ppn by sex & age
    inv_this_sum_nhat:= 1/this_sum_nhat;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
        phat_ad_sa[ i_yr][ i_s][ i_a]:= nhat_ad_sa[ i_yr][ i_s][ i_a] * inv_this_sum_nhat;
      END; // age
    END; // sex
  END; // year
END;

PROCEDURE Tckn_est_obj. unpack_growth(
  CONST parvec{npar}: ARRAY_1D);
VAR
  i_p, i_s, i_l, i_a: INTEGER;
  mean_l_sa, sd_l_sa, inv_sd_l_sa,
    cump_min_l, scal_min_l, scal_l,
    last_cump, this_cump: DOUBLE;
BEGIN
  // Destination will contain transformed vals; fix later
  FOR i_p:= 1 TO npar_vb_mean_Linf DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      vb_mean_Linf[ i_s] += parvec[ curipar] * log_vb_mean_Linf_desmat[ i_s][ i_p];
    END;
  END;

  FOR i_p:= 1 TO npar_vb_k DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      vb_k[ i_s] += parvec[ curipar] * log_vb_k_desmat[ i_s][ i_p];
    END;
  END;

  FOR i_p:= 1 TO npar_vb_t0 DO BEGIN
    INCR( curipar);
    taming[ curipar]:= 0;
    FOR i_s:= min_sex TO max_sex DO BEGIN
      vb_t0[ i_s] += parvec[ curipar] * I_vb_t0_desmat[ i_s][ i_p];
    END;
  END;

  FOR i_p:= 1 TO npar_vb_cv_Linf DO BEGIN
    INCR( curipar);
    FOR i_s:= min_sex TO max_sex DO BEGIN
      vb_cv_Linf[ i_s] += parvec[ curipar] * log_vb_cv_Linf_desmat[ i_s][ i_p];
    END;
  END;

  // Transform...
  FOR i_s:= min_sex TO max_sex DO BEGIN
    vb_mean_Linf[ i_s]:= EXP( vb_mean_Linf[ i_s]);
    vb_k[ i_s]:= EXP( vb_k[ i_s]);
    // t0 can be +ve or -ve; no tmfn reqd
    vb_cv_Linf[ i_s]:= EXP( vb_cv_Linf[ i_s]);
  END;

  // ... and compute entire growth dsn
  FOR i_s:= min_sex TO max_sex DO BEGIN
    FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
      mean_l_sa:= vb_mean_Linf[ i_s] * (1 - exp( -vb_k[ i_s] * (i_a - vb_t0[ i_s])));
      sd_l_sa:= mean_l_sa * vb_cv_Linf[ i_s];
      inv_sd_l_sa:= 1/sd_l_sa;
      scal_min_l:= (min_ad_l - 0.5 - mean_l_sa) * inv_sd_l_sa;

      // Undersized fish need a ppn, and a mean size from truncated Normal
      cump_min_l:= pt_nueveni( scal_min_l, t_or_norm);
      lunder[ i_s][ i_a]:= mean_l_sa + sd_l_sa *
          mean_t_nueveni_trunclt( scal_min_l, cump_min_l, t_or_norm);
      punder[ i_s][ i_a]:= cump_min_l;

      // No "minus-group"!
      last_cump:= cump_min_l;
      FOR i_l:= min_ad_l TO max_ad_l-1 DO BEGIN
        // Do on separate line to avoid complic deriv and FU in AD-R with var/const
        scal_l:= (i_l + 0.5 - mean_l_sa) * inv_sd_l_sa;
        this_cump:= pt_nueveni( scal_l, t_or_norm);
        pl_sa[ i_s][ i_l][ i_a]:= this_cump - last_cump;
        last_cump:= this_cump;
      END; // length

      pl_sa[ i_s][  max_ad_l][ i_a]:= 1 - last_cump;
    END; // age
  END; // sex
END;

PROCEDURE Tckn_est_obj. unpack_tresid(
  CONST parvec{npar}: ARRAY_1D);
VAR
  i_p, i_s, i_l, i_a: INTEGER;
  slope, inv_tresid_reflen, lgt_tresid_lunder_at_a: DOUBLE;
BEGIN
  // Destination will contain log-val; fix later
  FOR i_p:= 1 TO npar_tresid DO BEGIN
    INCR( curipar);
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        INCR( tresid[ i_s][ i_l], parvec[ curipar] * logit_tresid_desmat[ i_s][ i_l][ i_p]);
      END; // length
    END; // sex
  END; // par

  inv_tresid_reflen:= 1/inv_logit( tresid[ min_sex][ i_reflen]); // norm sexes jointly not separately
  FOR i_s:= min_sex TO max_sex DO BEGIN
    // Undersize: use a nasty fudge. Don't want to bother with cuspline etc
    // ... so take logit-linear extrapolation over two lowest Lclasses
    // ... back to lunder (the mean)
    // Must do undersize-at-age first, before tresid itself gets inverse-logitted
    slope:= tresid[ i_s][ min_ad_l+1] - tresid[ i_s][ min_ad_l];
    FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
      lgt_tresid_lunder_at_a:= tresid[ i_s][ min_ad_l] + slope * (lunder[ i_s][ i_a] - min_ad_l);
      tresid_under[ i_s][ i_a]:= inv_tresid_reflen * inv_logit( lgt_tresid_lunder_at_a);
    END;

    // Now can do length
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      tresid[ i_s][ i_l]:= inv_tresid_reflen * inv_logit( tresid[ i_s][ i_l]);
    END; // length
  END; // sex
END;

PROCEDURE Tckn_est_obj. unpack_male_daily_reprod(
  CONST parvec{npar}: ARRAY_1D);
VAR
  i_p, i_l: INTEGER;
  this_drm, tot, inv_tot: DOUBLE;
BEGIN
  // Destination will contain log-val; fix later
  FOR i_p:= 1 TO npar_daily_reprodm DO BEGIN
    INCR( curipar);
    FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
      INCR( daily_reprod[ male][ i_l], parvec[ curipar] * log_daily_reprodm_desmat[ i_l][ i_p]);
    END; // length
  END; // par

  tot:= 0;
  FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
    this_drm:= EXP( daily_reprod[ male][ i_l]);
    daily_reprod[ male][ i_l]:= this_drm;
    tot += this_drm;
  END; // length

  inv_tot:= 1/tot;
  FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
    daily_reprod[ male][ i_l] *= inv_tot;
  END; // length
END;

{$IFNDEF AD}
PROCEDURE Tckn_est_obj. compute_exp_a_given_ls_exportee();
VAR
  i_yr, i_s, i_l, i_a: INTEGER;
  this_p_ls, this_p_lsa, multor: DOUBLE;
BEGIN
  FOR i_yr:= min_ad_yr TO max_ad_yr DO BEGIN
    FOR i_s:= min_sex TO max_sex DO BEGIN
      FOR i_l:= min_ad_l TO max_ad_l DO BEGIN
        // Could take the tresid/qsel mult out of this loop
        this_p_ls:= 0;
        FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
          this_p_lsa:= tresid[ i_s][ i_l] * pl_sa[ i_s][ i_l][ i_a] * phat_ad_sa[ i_yr][ i_s][ i_a];
          e_rs_a_given_ls[ i_yr][ i_s][ i_l][ i_a]:= this_p_lsa;
          this_p_ls += this_p_lsa;
        END; // i_a

        multor:= tot_rs_a_given_ls[ i_yr][ i_s][ i_l] / this_p_ls;
        FOR i_a:= min_ad_a TO max_ad_a DO BEGIN
          e_rs_a_given_ls[ i_yr][ i_s][ i_l][ i_a] *= multor;
        END;
      END; // i_l
    END; // i_s
  END; // i_yr
END;
{$ENDIF}{AD}

END.

